<?php
# ----------------------------------------------------------------------
# temporary settings, adjust after testing
#
$wsDebug		= false;	
$wsDebug		= true;		// ##### make comment after testing
#
#-----------------------------------------------------------------------
# display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
$SITE 		= array();	// to store all settings for all scripts
$pathString	= '';		// to store messages form scripts before echo can be used
#
$pageName	= 'index.php';	
$pageVersion	= '3.01 2014-11-15';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {
	$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;
}
$pathString.= '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageName]." -->".PHP_EOL;  // echo all modulenames loaded
# ----------------------------------------------------------------------------------------
# 3.01 2014-11-15 added wide=100% / wide=1234px  for ipad type use 
# ----------------------------------------------------------------------------------------
$extraP			= '';
#-------------- check debug settings -----------------------------------------------------
if (isset($_REQUEST['debug']) || $wsDebug == true) {
	$wsDebug	= true;
	ini_set('display_errors', 'On'); 
	error_reporting(E_ALL);	
	$pathString.= '<!-- debug is switched on by index.php because of user request - error reporting ALL -->'.PHP_EOL;
	if (isset($_REQUEST['wp'])) {
		$wp = strtoupper($_REQUEST['wp']);
		if ($wp == 'WD'  || $wp == 'CW' || $wp == 'MB' || $wp == 'WL' || $wp == 'MH' || $wp == 'CU' ||  $wp == 'WC' ||  $wp == 'DW') {
			$SITE['WXsoftware']     = $wp;
			$pathString             .= '<!-- user switches the weatherprogram to '.$wp.' -->'.PHP_EOL;
			$extraP                 ='&amp;wp='.$wp;
		}
		
	}
}
# -------- first we load the sitewide settings we need from now on 		------------------
include 'wsSettings.php';
$lang   = $SITE['lang'];	
if (isset($_REQUEST['ipad']) )	{       // modify standard settings if page formatting ipad is requested
        include 'wsSettingsIpad.php';
} else {$SITE['ipad']           = false;}
#
# ------------------------   check if we are allowed to set cookie and process all cookies
if ($SITE['cookieSupport'] == true) {
	include 'wsCookie.php' ;
}
# -----------------------------------------------------  check if we go to the mobile site
if ($SITE['mobileSite'] <> "") {
	$mobi 	= false;
	$cookie = $SITE['cookieName']."skip";
	if (!isset ($_COOKIE[$cookie])) {
		require_once('./mobi/mobile_device_detect.php');// credits : http://detectmobilebrowsers.mobi/
		$mobile =	mobile_device_detect(true,false,true,true,true,true,true,'','');
		if ($mobile) {
			if (!isset ($_REQUEST['mobi']) ) { 
				$mobi           = 10;
				$cookieAllowed  = true;  
				wsSetcookie($cookie, "skip", time()+3600);  // if users returns in 60 min, the normal site will be used
			}
			if (isset ($_REQUEST['pcSite']) || isset ($_SESSION['pcSite']) ) {
				$_SESSION['pcSite']	= 'Y';
				$mobi                   = false;
			}
		}
	} 
	if (isset ($_REQUEST['p']) ) {   // pc user wants to go to mobile site
		$pnr    = intval ( trim($_REQUEST['p']));
		if ($pnr == $SITE['mobilePageNr']) {
			$_REQUEST['mobi']       = 10;
		}
		
	}	
	if (isset ($_REQUEST['mobi']) ) {   // pc user wants to go to mobile site
		$mobi = intval ( trim($_REQUEST['mobi']));
	}
	if ($mobi <> false) {
		include($SITE['mobileSite']);
		exit;			// user 
	}
}
#------------------------  now we are processing requests for pages on our  normal website
# A template set for personal weather stations
# Developer :	(c) 2011 Weerstation Leuven. Based on previous scripts o.a. from Ken True (Saratoga.org)
# Use and adapt as you wish.
#
#Module summary:
# 1.	wsSetting.php 				sitewide settings
# loads	settingsWeather.php			weathersoftware settings
#
# 2		wsCookie.php				check cookies set and registers if we are allowed to set cookies
#
# 3.	wsLangFunctions.php			language translation functions
#
# 4. 	wsMenuLoad.php				fills array with all menu choices and extras from incMenuData.xml
#
# 5. 	wsGetdata					process all variables from the weatherprogram into array with values
# loads wsLoaddata  				generates table with weathervalues to be used in Ajax/Javascript updates
#
# 6. 	
#
# 7.	Footer	the footer includes also WhoIsOnline functions etc.
#
ini_set('default_charset', $SITE['charset']);
require_once($SITE['langFunc']);			// so we can translate  to required lang
#
$titleOfPage = langtransstr($SITE['organ']) . " - " .langtransstr('Start page'); 
#
#-----------------------------------------------------------------------------------------
#	decide which page to load based on the users input      
#-----------------------------------------------------------------------------------------
$p = $SITE['noChoice'];
if (isset($_GET['p'])) {
	$p = $_GET['p'];	
}elseif (isset($_POST['p'])) {
	$p = $_POST['p'];		
}
if ( isset ($_POST['donotwant']) ) {$p = $SITE['noChoice'];}  // if user reject cookie, goback to startpage
#-----------------------------------------------------------------------------------------
#	load menu data into $menuArray for pagenumber checking and into a HTML string 
#-----------------------------------------------------------------------------------------
require_once($SITE['menuLoad']);
#
if (isset($menuArray[$p]['choice'])) {	// valid page number
	$folder 	= $menuArray[$p]['folder']; 
	$gizmo  	= $menuArray[$p]['gizmo'];
	$css		= $menuArray[$p]['css'];
	$head		= $menuArray[$p]['head'];
	$link		= $menuArray[$p]['link'];
	$noutf8         = $menuArray[$p]['noutf8'];        
	$titleOfPage	= langtransstr($menuArray[$p]['title']). " - ".langtransstr($SITE['organ']);
	$phpself	= "index.php?p=".$p;// if a page wants to reload itself later it uses this var because a page does not know its menunumber
} else {
	header ("Location: index.php");		// back to index/startpage if someone tries an
	exit;  								//  out of range / non existing page
}
# test for        noutf8  = "WINDOWS-1252"
if ( $SITE['charset'] == 'UTF-8'
     && $noutf8 <> '') {
        $SITE['charset'] = $noutf8;
        ini_set('default_charset', $SITE['charset']);
        $LANGLOOKUP 	= array();		// clean arrays with utf-8 language data
        $missingTrans	= array();
        $dir 		= $SITE['langDir'];
        langMergeFile   ( $dir );		// reload lang files with nonutf8 data
        $menuArray      = array();
        $DropdownMenuText = '';
        $level		= 1;	
        wsMenuGen 	($xmlStr);		// generate new menu files
}
#
$SITE['pageRequest'] = $p.'|'.$link;
#-----------------------------------------------------------------------------------------
#            generate headers and first part of page
#-----------------------------------------------------------------------------------------
if (!isset ($lang) ) {$lang = $SITE['lang'];}
header("Content-Type: text/html; charset=".strtoupper($SITE['charset']));
echo'<!DOCTYPE html>
<html lang="'.$lang.'">
<head>'.PHP_EOL;
#echo $pathString;    					// print list of loaded modules until this point
#$pathString	= '';					// and reset for further use
$htmlTxt	= '';					// in this string we assemble the html output
$htmlTxt.= '	<meta charset="'.strtoupper($SITE['charset']).'"/>'.PHP_EOL;
#-----------------------------------------------------------------------------------------
# javascript for gizmo.This is in header1 a one line high weather description with rotating content: temp / baro a.s.o.
# 		or  a set of weather variables boxes in header2
# the gizmo is only shown on a page if requested in the menu file entry for that page
#	AND if allowed by the settings
#-----------------------------------------------------------------------------------------
if ($gizmo) {   									// menu file request a gizmo for this page, if also it is set in site-settings 
	if (isset($SITE['ajaxGizmoShow']) and $SITE['ajaxGizmoShow']) {	
													// and it is set in site-settings , than display it
		$htmlTxt.='	<script type="text/javascript" src="'.$SITE['ajaxGizmojs'] .'"></script>'.PHP_EOL;
		if (!isset($SITE['UV']) || !$SITE['UV']) {	// turn of display of UV value if no UV sensor present
			$htmlTxt.='	<script type="text/javascript"> showUV = false; </script>'.PHP_EOL;
		} // end of turn gizmo UV display off
#	
		if(isset($SITE['wsAjaxScript'])) { 			// is there a realtime update script for this site allowed
			$htmlTxt.='	<script type="text/javascript">
		var wsUrl       = "'.$SITE['wsAjaxDataLoad'].'?lang='.$lang.'&wp='.$SITE['WXsoftware'].'";   
		var reloadTime 	= '.$SITE['wsAjaxDataTime'].'000;
	</script>'.PHP_EOL;
			$htmlTxt.='	<script type="text/javascript" src="'.$SITE['wsAjaxScript'].'"></script>'.PHP_EOL;
		} 	// end if ajaxScript
	} // end of showGizmo for this site
} // end of gizmo for this page
#
$htmlTxt.= '	<script type="text/javascript" src="javaScripts/styleMenu.js"></script>'.PHP_EOL;
if (isset ($SITE['autoRefresh'])  &&  $SITE['autoRefresh'] > 60 ){
	$htmlTxt.= '	<meta http-equiv="refresh" content="'.$SITE['autoRefresh'].'" />'.PHP_EOL;
}
$htmlTxt.= '	<meta name="description" content="'.$titleOfPage.'" />'.PHP_EOL;
$htmlTxt.= '    <meta name="apple-mobile-web-app-capable" content="yes" />'.PHP_EOL;
$htmlTxt.= '	<meta http-equiv="Content-Type" content="text/html; charset='.strtoupper($SITE['charset']).'"/>'.PHP_EOL;
#-----------------------------------------------------------------------------------------
#            standard stylesheets
#-----------------------------------------------------------------------------------------
$htmlTxt .='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSscreen'].'" media="all" title="screen" />'.PHP_EOL;
$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSStable'].'" media="all" title="screen" />'.PHP_EOL;
if ($SITE['stripAll'] || $SITE['menuPlace'] == 'H') {
	$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSmenuHor'].'" media="all" title="screen" />'.PHP_EOL;
} else {
	$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSmenuVer'].'" media="all" title="screen" />'.PHP_EOL;
}
#------------------------------------------------------------------------------------------
#   extra stylesheet for this menuchoice
#------------------------------------------------------------------------------------------
if ($css <> ''){
	$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$css.'" media="all" title="screen" />'.PHP_EOL;
}
$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSmood'].'" media="all" title="screen" />'.PHP_EOL;
$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSprint'].'" media="print" />'.PHP_EOL;
$htmlTxt.='	<link rel="stylesheet" href="gauges/css/gauges-ss.css" />'.PHP_EOL;
$htmlTxt.='	<link rel="stylesheet" href="gauges/css/ddimgtooltip.css" />'.PHP_EOL;


#-----------------------------------------------------------------------------------------
# other header lines 
#-----------------------------------------------------------------------------------------
$htmlTxt.='	<link rel="icon" href="img/icon.png" type="image/x-icon" />
	<meta name="Keywords" content="weather, Weather, temperature, dew point, humidity,
	 forecast, Davis Vantage Pro,  Weather, '.$SITE['organ'].', weather conditions, 
	 live weather, live weather conditions, weather data, weather history, Meteohub " />
	<title>'.$titleOfPage.'</title>'.PHP_EOL;
echo $htmlTxt;							// now all header text is sent
#-----------------------------------------------------------------------------------------
# general functions used in all scripts
#-----------------------------------------------------------------------------------------
if ($wsDebug) { $pathString	.= '<!-- '.'index.php'.' load script with general functions used in all scripts  -->'.PHP_EOL;}
include_once($SITE['functions']);		// general functions for data processing
if ($wsDebug) { echo $pathString; }
$pathString		= '';					// reset for further use
#-----------------------------------------------------------------------------------------
# a different script for every supported weather program is used to convert weatherdata
#-----------------------------------------------------------------------------------------
if ($wsDebug) { echo '<!-- index.php => '.$SITE['getData'].': get data from weatherprogr / wu sites / metar files -->'.PHP_EOL;}
include_once($SITE['getData']);			// get data from weatherprogr / wu sites / metar files
#
if ($wsDebug) { echo '<!-- index.php => '.$SITE['loadData'].': load all weatherdata into a javascript string -->'.PHP_EOL;}
include_once($SITE['loadData']);		// load weatherdata in string (=array)for eval in javascript
$vars           = array();
$string2        =str_replace('ajaxVars','$vars',$string1);  // change javascript to php
eval($string2);					// all vars for use in headings and ajax "normal" pages are now loaded into $vars array
#-----------------------------------------------------------------------------------------
#	do we want a colored background a.s.o.
#-----------------------------------------------------------------------------------------
if ($SITE['colorNumber'] <>  0) {		// fixed color scheme (1 and higher) overrides dynamic (0) based on weather conditions
	$headerClass = $SITE['colorStyles'][$SITE['colorNumber']];	
}
if ($wsDebug) { echo 	"<!-- index.php: icon = $ccnIconNr  , hdrclass = $headerClass -->".PHP_EOL;}
#-----------------------------------------------------------------------------------------
# we calculate the width of the page and the width of the usable area
#-----------------------------------------------------------------------------------------
#
if (isset($SITE['pageWidth'])) { $pageWidth = $SITE['pageWidth'];} else { $pageWidth	= '1000';}
if (isset($SITE['menuWidth'])) { $menuWidth	= $SITE['menuWidth'];} else { $menuWidth	='140';}
$areaWidth = $pageWidth;
if ($SITE['sideDisplay'] || $SITE['menuPlace'] <> 'H') {
	$areaWidth	= $pageWidth - $menuWidth;// usable area = pagewidth minus optional menu/sidecolom width
}
#-----------------------------------------------------------------------------------------
#---  extras for the html head section go between here   ---------------------------------
#
if ($head <> ''){				// extras to be included based on the menu settings F.i. generate a special css a.s.o.
	include($head); 			// load  /execute the requested extra's
}
if (!isset($noDocready) ) {			// WU-Graphs  v 1.8.0 /  2010 Radomir Luza. cannot run with this code, it has its own version of it
echo '<script type="text/javascript">
var docready=[],$=function(){return{ready:function(fn){docready.push(fn)}}};
</script>
'.PHP_EOL;
}
#
#---------  and here     -----------------------------------------------------------------
echo '</head>'.PHP_EOL;
echo '<body class="'.$headerClass.'">'.PHP_EOL;
#-----------------------------------------------------------------------------------------
# Now we set a picture as background based on the  settings
#-----------------------------------------------------------------------------------------
$img= str_replace ('ws_', '', $headerClass);
$fileString='img/background-'.$img.'.jpg';
if (file_exists($fileString)) {
	echo '<img src="'.$fileString.'" class="bg" alt="" />'.PHP_EOL;
}
#-----------------------------------------------------------------------------------------
# we start outputting the page
#-----------------------------------------------------------------------------------------
echo '<!-- page wrapper -->'.PHP_EOL;
#if (!$SITE['stripAll']) {echo '<div style=""><br /></div>'.PHP_EOL;}
if ($SITE['stripAll'] && $SITE['stripMenu']) {
        echo '<div id="pagina" style="width:100%; position: relative; z-index: 2;">'.PHP_EOL;       
} else {
        echo '<div id="pagina" style="width:'.$pageWidth.'px; position: relative; z-index: 2;">'.PHP_EOL;
}
#-----------------------------------------------------------------------------------------
# Warnings boxes
include ($SITE['warningScript']);
if (!isset($SITE['warningInside'])) { $SITE['warningInside'] = false;}
if (isset ($wrnHead) ) {echo $wrnHead;}
if (isset ($SITE['banners']) && $SITE['banners'] && $SITE['bannerTop']	) {include $SITE['bannerTopTxt'];}
if ($SITE['warningInside'] <> true) { echo $wrnStrings;} 
#
if (!$SITE['stripAll']) { 				// a normal page incl headers footers and (optional/default) a menu
	#-------------------------------------------------------------------------------------
	#  header either low (type 1)  or 2 = default
	#-------------------------------------------------------------------------------------
	$header			= 2;			// default header = 2
	if ( isset($SITE['header']) ){
		$header		= $SITE['header'];	//  which header 1 or 2
	}
	include ("wsHeader$header.php");
	#-------------------------------------------------------------------------------------
	#  where do we place the menu
	#-------------------------------------------------------------------------------------
	if (!$SITE['stripMenu'] && $SITE['menuPlace'] == 'H') { // no strip menu and horizontal
	#  							// horizontal menu
		echo '<div id="menu-hor" style="width: '.$areaWidth.'px; margin: 5px 5px 0px 5px;">'.PHP_EOL;
		echo '<ul id="nav">'.PHP_EOL;
		echo $DropdownMenuText;
		echo '</ul>'.PHP_EOL;
		echo '</div>'.PHP_EOL;
	} 
	if ($SITE['sideDisplay'] || $SITE['menuPlace'] <> 'H') {	// vertical menu in side area
	#  								//  vertical menu in side area
		echo '<!-- first colomn with links to external sites and or vertical menu-->'.PHP_EOL;
		echo '<div id="info-ver">'.PHP_EOL;
		include_once($SITE['sideInc']);
		echo '</div>'.PHP_EOL;   		//
		echo '<!-- end first colomn -->'.PHP_EOL;
		$areaWidth =  $pageWidth - $menuWidth;	// subtract menu width and 10px margin	
	}
} else { 
        $areaWidth =  $pageWidth;						
	if (!$SITE['stripMenu']) {              // strip all extras but do we want a menu?
		echo '<div id="menu-hor" style="width: '.($areaWidth - 10).'px; margin: 5px;">'.PHP_EOL;	// only a horizontal menu is possibles as there is no sidecolom etc
		echo '<ul id="nav">'.PHP_EOL.$DropdownMenuText;
		echo '</ul>'.PHP_EOL;
		echo '</div>'.PHP_EOL;
	}
}
if ($SITE['stripAll'] && $SITE['stripMenu']) {
        echo '<div id="data-area" style="width: 100%; ">'.PHP_EOL;
} else {
        if (isset($SITE['floatTop']) && $SITE['floatTop'] <> '') {include $SITE['floatTop'];}
        echo '<div id="data-area" style="width: '.$areaWidth.'px; ">'.PHP_EOL;
}
# 
if ($SITE['warningInside']) {echo $wrnStrings;} // check for warnings if not already done
#---------------------------------------------------------------------------
#		load the requested page as specified in menu settings
#
echo '<!-- index.php: loading program: '.$link.' -->'.PHP_EOL;
include($link);
echo'	</div>
<!-- end data area -->'.PHP_EOL;
#---------------------------------------------------------------------------
#		bottom area and footer
#
#if (isset ($SITE['banners']) && $SITE['banners'] && $SITE['bannerBottom']	) {include $SITE['bannerBottomTxt'];}
#
if (!$SITE['stripAll'] && $SITE['bottomDysplay']) {	// optional bottom area
	echo '<div id="bottom" class="doNotPrint">'.PHP_EOL;
	include ($SITE['bottomInc']);
	echo '</div>'.PHP_EOL;
}
#if (isset ($SITE['banners']) && $SITE['banners'] && $SITE['bannerBottom']	) {include $SITE['bannerBottomTxt'];}
if (!$SITE['stripAll']) {
	include($SITE['footer']);  // always the footer with optional whoisonline
} else {
	echo '<div id="footer" class="doNotPrint" style="height: 0px;"></div>';
}
if (isset ($SITE['banners']) && $SITE['banners'] && $SITE['bannerBottom']	) {include $SITE['bannerBottomTxt'];}
?>
</div>
<!-- end id="page" wrapper -->
<!--
<?php 
echo '_____________________________|_____________________________'.PHP_EOL;
echo '              loaded modules | version number'.PHP_EOL;
echo '_____________________________|_____________________________'.PHP_EOL;
foreach ( $SITE['wsModules'] as $key => $val) {
	echo substr('                       '.$key.' | ',-31,31).$val.PHP_EOL;
}
echo '_____________________________|_____________________________'.PHP_EOL;
?>
-->
<br />
 </body>
</html>
<?php 
#
# Leave this code here .. it will help you see what language translations are missing by running any page on your
# website with a ?show=missing argument
#
$langfile	= '';
$string		= '';
if(isset($_REQUEST['show']) and strtolower($_REQUEST['show']) == 'missing') {
	echo '<!-- '.'index.php'.' missing langlookup entries for lang='.$lang.PHP_EOL;
	foreach ($missingTrans as $key => $val) {
		$string.= "langlookup|$key|$key|".PHP_EOL;
	}
	if (strlen($string) > 0) {
		echo $string;
		if ($wsDebug) {
			$langfile 	= './lang/wsLanguage-' . $lang .'-local.txt';
			file_put_contents($langfile,$string,FILE_APPEND);
		}
	}
	echo count($missingTrans).' entries.  End of missing langlookup entries -->'.PHP_EOL;
}
# -------------------- function only for index.php
function wsSetcookie ($cookie, $doSomething,$time) {
	global $cookieAllowed;
	if ($cookieAllowed == true) {
		setcookie($cookie, $doSomething, $time); // cookie expires in 1 hour
	} else {
		echo 'cookie set without consent'; exit;
	}
	return;
}

?>
